var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { InjectVegaSlimmer, MapToComponentField, MapToComponentMethod, VegaSlimmer } from 'vega-slimmer/core';
import { MutationObserverSlimmer } from '../../../../helpers/slimmers/mutation-observer/mutation-observer-slimmer';
import { TagNameMutationFilter } from '../../../../helpers/slimmers/mutation-observer/mutation-observer-filters';
/**
 * The class `VegaInputSelectItemsSlotController` extends `VegaSlimmer` and manages
 * appending host items to a dropdown element.
 */
export class VegaComboBoxItemsSlotController extends VegaSlimmer {
  constructor() {
    super(...arguments);
    this.mutationObserver = new MutationObserverSlimmer({
      mutationFilter: TagNameMutationFilter('VEGA-DROPDOWN-ITEM'),
      options: {
        childList: true,
        subtree: true,
      },
      callback: 
      /*
       * The below method is e2e-test covered in
       * @see{module:vega-combo-box-template-slot-change-e2e}
       */
      /* istanbul ignore next */
      // eslint-disable-next-line jsdoc/require-jsdoc
      () => this.appendHostItemsToDropdown(),
    });
  }
  /**
   * Component lifecycle - [componentDidLoad]
   */
  componentDidLoad() {
    this.appendHostItemsToDropdown();
  }
  /**
   * The function appends host items to a dropdown element.
   */
  appendHostItemsToDropdown() {
    this.dropdownRenderer.replaceItemsSlot(this.host.querySelector('[slot=items]'));
  }
}
__decorate([
  InjectVegaSlimmer()
], VegaComboBoxItemsSlotController.prototype, "mutationObserver", void 0);
__decorate([
  MapToComponentField()
], VegaComboBoxItemsSlotController.prototype, "host", void 0);
__decorate([
  MapToComponentField()
], VegaComboBoxItemsSlotController.prototype, "dropdownRenderer", void 0);
__decorate([
  MapToComponentMethod('componentDidLoad')
], VegaComboBoxItemsSlotController.prototype, "componentDidLoad", null);
